<template>
  <a v-if="blob" :href="blob"><slot>Download table as CSV</slot></a>
</template>
<script>
import Papa from "papaparse";

const flatten = (x) => (Array.isArray(x) ? x.join(",") : x);
export default {
  props: {
    array: {
      type: Array,
      required: true,
    },
    fields: {
      type: Array,
      required: false,
      default: () => [],
    },
  },
  computed: {
    blob() {
      if (!this.csv) {
        return null;
      }
      return URL.createObjectURL(new Blob([this.csv], { type: "text/csv" }));
    },
    csv() {
      if (!Array.isArray(this.array)) {
        return null;
      }
      return Papa.unparse(this.array.map(this.reducer), {
        delimiter: "\t",
      });
    },
    reducer() {
      if (Array.isArray(this.fields) && this.fields.length > 0) {
        return (item) => {
          const ret = {};
          for (const field of this.fields) {
            ret[field] = flatten(item[field]);
          }
          return ret;
        };
      }
      return (item) => item;
    },
  },
};
</script>
